/**
 * 
 */
package snippet.gef.sample2.gef.editor;

import org.eclipse.draw2d.Figure;
import org.eclipse.draw2d.geometry.Rectangle;
import org.eclipse.gef.tools.CellEditorLocator;
import org.eclipse.jface.viewers.CellEditor;
import org.eclipse.swt.widgets.Text;

/**
 * @author amergey
 *
 */
public class LabelCellEditorLocator implements CellEditorLocator {
	private Figure mFigure;

	public LabelCellEditorLocator(Figure pFigure) {
		super();
		mFigure = pFigure;
	}

	/**
	 * @see org.eclipse.gef.tools.CellEditorLocator#relocate(org.eclipse.jface.viewers.CellEditor)
	 */
	@Override
	public void relocate(CellEditor pCelleditor) {
		Text text = (Text) pCelleditor.getControl();
		Rectangle rect = mFigure.getClientArea();
		mFigure.translateToAbsolute(rect);
		org.eclipse.swt.graphics.Rectangle trim = text.computeTrim(0, 0, 0, 0);
		rect.translate(trim.x, trim.y);
		rect.width += trim.width;
		rect.height += trim.height;
		text.setBounds(rect.x, rect.y, rect.width, rect.height);
	}

}
