package snippet.gef.sample2.gef.figure;

import org.eclipse.draw2d.Figure;
import org.eclipse.draw2d.IFigure;
import org.eclipse.draw2d.Label;
import org.eclipse.draw2d.LineBorder;
import org.eclipse.draw2d.PositionConstants;
import org.eclipse.draw2d.ToolbarLayout;
import org.eclipse.swt.graphics.Color;

public class EntityFigure extends Figure {

	private Label mTitleLabel;
	private CompartmentFigure mAttrsComp;

	public EntityFigure() {
		doCreate();
	}

	public void setEntityLabel(String pLabel) {
		mTitleLabel.setText(pLabel);
	}

	private void doCreate() {
		// Color BG = new Color(null, 16, 37, 63);
		Color BG = new Color(null, 56, 93, 138);

		LineBorder border = new LineBorder();
		border.setColor(BG);
		border.setWidth(2);
		this.setBorder(border);

		this.setBackgroundColor(BG);
		this.setOpaque(true);
		mTitleLabel = new Label("");
		mTitleLabel.setForegroundColor(new Color(null, 255, 255, 255));
		mTitleLabel.setLabelAlignment(PositionConstants.LEFT);
		super.add(mTitleLabel,null,-1);
		// figure.setBorder(new GroupBoxBorder(label));
		mAttrsComp = new CompartmentFigure();
		mAttrsComp.setBackgroundColor(new Color(null, 242, 242, 242));
		mAttrsComp.setOpaque(true);
		super.add(mAttrsComp,null,-1);

		this.setLayoutManager(new ToolbarLayout());
	}

	/**
	 * @see org.eclipse.draw2d.Figure#add(org.eclipse.draw2d.IFigure, java.lang.Object, int)
	 */
	@Override
	public void add(IFigure pFigure, Object pConstraint, int pIndex) {
		if(pFigure instanceof AttributeFigure){
			mAttrsComp.add(pFigure,pConstraint,pIndex);
		} else {
			super.add(pFigure,pConstraint,pIndex);
		}
	}

	/**
	 * @see org.eclipse.draw2d.Figure#remove(org.eclipse.draw2d.IFigure)
	 */
	@Override
	public void remove(IFigure pFigure) {
		if(pFigure instanceof AttributeFigure){
			mAttrsComp.remove(pFigure);
		} else {
			super.remove(pFigure);
		}
	}	
	
	
}
