/**
 * 
 */
package snippet.gef.sample2.gef.part.factory;

import org.eclipse.gef.EditPart;
import org.eclipse.gef.EditPartFactory;
import org.eclipse.gef.editparts.AbstractGraphicalEditPart;

import snippet.gef.sample2.ModelDesignGraphEditor;
import snippet.gef.sample2.gef.part.AttributePart;
import snippet.gef.sample2.gef.part.EntityPart;
import snippet.gef.sample2.gef.part.ModelPart;
import snippet.gef.sample2.model.Attribute;
import snippet.gef.sample2.model.Entity;
import snippet.gef.sample2.model.Model;

/**
 * @author amergey
 *
 */
public class ModelDesignPartFactory implements EditPartFactory {
	private ModelDesignGraphEditor mEditor;

	public ModelDesignPartFactory(ModelDesignGraphEditor pEditor) {
		super();
		mEditor = pEditor;
	}

	/**
	 * @see org.eclipse.gef.EditPartFactory#createEditPart(org.eclipse.gef.EditPart, java.lang.Object)
	 */
	@Override
	public EditPart createEditPart(EditPart pContext, Object pModel) {
		AbstractGraphicalEditPart part=null;
		
		if (pModel instanceof Model){
			part=new ModelPart();
		} else if (pModel instanceof Entity){
			part=new EntityPart();
		} else if (pModel instanceof Attribute){
			part=new AttributePart();
		}
		
		part.setModel(pModel);
		
		return part;
	}

}
