/**
 * 
 */
package snippet.gef.sample2.gef.policy;

import org.eclipse.gef.commands.Command;
import org.eclipse.gef.editpolicies.DirectEditPolicy;
import org.eclipse.gef.requests.DirectEditRequest;

import snippet.gef.sample2.gef.command.ChangeEntityLabelCommand;
import snippet.gef.sample2.gef.figure.EntityFigure;
import snippet.gef.sample2.gef.part.EntityPart;
import snippet.gef.sample2.model.Entity;

/**
 * @author amergey
 *
 */
public class EntityDirectEditPolicy extends DirectEditPolicy {

	/**
	 * @see org.eclipse.gef.editpolicies.DirectEditPolicy#getDirectEditCommand(org.eclipse.gef.requests.DirectEditRequest)
	 */
	@Override
	protected Command getDirectEditCommand(DirectEditRequest pRequest) {
		String labelText = (String) pRequest.getCellEditor().getValue();
		EntityPart label = (EntityPart) getHost();
		ChangeEntityLabelCommand command = new ChangeEntityLabelCommand(
				(Entity) label.getModel(), labelText);
		return command;
	}

	/**
	 * @see org.eclipse.gef.editpolicies.DirectEditPolicy#showCurrentEditValue(org.eclipse.gef.requests.DirectEditRequest)
	 */
	@Override
	protected void showCurrentEditValue(DirectEditRequest pRequest) {
		String value = (String) pRequest.getCellEditor().getValue();
		((EntityFigure) getHostFigure()).setEntityLabel(value);
	}

}
